/*
 * Copyright (C) 2012 eXo Platform SAS.
 *
 * This is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as
 * published by the Free Software Foundation; either version 2.1 of
 * the License, or (at your option) any later version.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this software; if not, write to the Free
 * Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 * 02110-1301 USA, or see the FSF site: http://www.fsf.org.
 */

package juzu.impl.plugin.template.metadata;

import juzu.Path;
import juzu.impl.template.spi.TemplateStub;
import juzu.template.Template;

/** @author <a href="mailto:julien.viet@exoplatform.com">Julien Viet</a> */
public class TemplateDescriptor {

  /** . */
  private final String path;

  /** . */
  private final Class<? extends Template> type;

  /** . */
  private final Class<? extends TemplateStub> stubType;

  public TemplateDescriptor(
      Class<? extends Template> type,
      Class<? extends TemplateStub> stubType) {
    Path path = type.getAnnotation(Path.class);

    //
    this.path = path.value();
    this.type = type;
    this.stubType = stubType;
  }

  public String getPath() {
    return path;
  }

  public Class<? extends Template> getType() {
    return type;
  }

  public Class<? extends TemplateStub> getStubType() {
    return stubType;
  }
}
